---
title: Window.showOpenFilePicker()
slug: Web/API/Window/showOpenFilePicker
tags:
  - File
  - File System Access API
  - Method
  - Window
  - working with files
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>showOpenFilePicker()</code></strong> method of the {{domxref("Window")}} interface shows a file picker that allows a user to select a file or multiple files and returns a handle for the file(s).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>FileSystemHandles</var> = Window.showOpenFilePicker();</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>options</em> {{optional_inline}}</dt>
 <dd>An optional object containing options, which are as follows:
 <ul>
  <li><code>multiple</code>: A {{jsxref('Boolean')}}. Default <code>false</code>. When set to <code>true</code> multiple files may be selected.</li>
  <li><code>excludeAcceptAllOption</code>:A {{jsxref('Boolean')}}. Default <code>false</code>. By default the picker should include an option to not apply any file type filters (instigated with the type option below). Setting this option to <code>true</code> means that option is <em>not</em> available.</li>
  <li><code>types</code>: An {{jsxref('Array')}} of allowed file types to pick. Each item is an object with the following options:
   <ul>
    <li><code>description</code>: An optional description of the category of files types allowed.</li>
    <li><code>accept</code>: An {{jsxref('Object')}} with the keys set to the <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types/Common_types">MIME type</a> and the values an {{jsxref('Array')}} of file extensions (see below for an example).</li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Array')}} of {{domxref('FileSystemFileHandle')}} objects.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>An AbortError is thrown if a user dismisses the prompt without making a selection or if a file selected is deemed too sensitive or dangerous to be exposed to the website.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Here we set the options object for passing into the method. We'll allow a selection of image file types, with no option to allow for all files types, or multiple file selection.</p>

<pre class="brush: js notranslate">const pickerOpts = {
  types: [
    {
      description: 'Images',
      accept: {
        'image/*': ['.png', '.gif', '.jpeg', '.jpg']
      }
    },
  ],
  excludeAcceptAllOption: true,
  multiple: false
};</pre>

<p>Next we can create an asynchronous function which show the file picker and return the selected file.</p>

<pre class="brush: js notranslate">// create a reference for our file handle
let fileHandle;

async function getFile() {
  // open file picker, destructure the one element returned array
  [fileHandle] = await window.showOpenFilePicker(pickerOpts);

  // run code with our fileHandle
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access','#api-showopenfilepicker','showOpenFilePicker')}}</td>
   <td>{{Spec2('File System Access')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.showOpenFilePicker")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
